#include "mbed.h" 
#include "Adafruit_FONA.h"
#include "SWO.h"
#include "LCD_DISCO_F429ZI.h"

#define FONA_RST PB_4
#define FONA_TX PA_9
#define FONA_RX PA_10
#define FONA_RI PB_7

//URL to request state of outputs
char url[80]="http://webserver.site88.net/getstate.php?color=All";

// this is a large buffer for replies
char replybuffer[255];
LCD_DISCO_F429ZI lcd;       //Create a LCD_DISCO_F429ZI object

// Note: there is only one hardware serial on the "nRF51 DK" board, so the SoftSerial is used instead. However it doesn't 100% work.
SWO_Channel SWO;

Adafruit_FONA fona(FONA_TX, FONA_RX, FONA_RST, FONA_RI);

// Turn on a LED when somebody call the FONA
DigitalOut led1(PC_5); // 1 = LED OFF on the "nRF51 DK" board
char RpmBuffer[1000];

void HTTP_Function(void);

void HTTP_Function()
{
    lcd.DisplayStringAtLine(5,(uint8_t*)"Inside HTTP");
    if (!fona.HTTP_setup(url))
    {
       lcd.DisplayStringAtLine(6,(uint8_t*)"Setup HTTP Read Failed");
    }
        
}
//Function: Sends AT Commands to initialise the Module
bool GSM_Init()
{
    // See if the FONA is responding
    if (! fona.begin(19200))
     {
        lcd.Clear(LCD_COLOR_BLUE);  
        lcd.DisplayStringAtLine(1,(uint8_t*)"Couldn't find FONA");
         return false;
     }
     else
     {
      //  lcd.Clear(LCD_COLOR_BLUE);  
        lcd.DisplayStringAtLine(1,(uint8_t*)"FONA is OK");
        
        //Configure a GPRS APN, username, and password.
        fona.setGPRSNetworkSettings("internet", "", "");
        
            // turn GPRS on.
        if (!fona.enableGPRS(true))
         {  
           lcd.DisplayStringAtLine(2,(uint8_t*)"Failed to turn on");
         }
         else
         {
          // lcd.Clear(LCD_COLOR_BLUE);  
           lcd.DisplayStringAtLine(2,(uint8_t*)"Successfully turned on GPRS");
         }
        
            if (fona.GPRSstate() == 5)
            {  
               lcd.DisplayStringAtLine(4,(uint8_t*)"Could not get GPRS state");
               return false;
            }
            else if(fona.GPRSstate() == 1)
            {
               lcd.DisplayStringAtLine(4,(uint8_t*)"GPRS attached");
                HTTP_Function();
            }
            else if(fona.GPRSstate() == 0)
            {
                 lcd.DisplayStringAtLine(4,(uint8_t*)"GPRS detached");
                
            }
             return true;
     }
}

int main()
 {
     lcd.Clear(LCD_COLOR_BLUE);  
     lcd.SetFont(&Font20); 
     lcd.SetBackColor(LCD_COLOR_BLUE);                     
     lcd.SetTextColor(LCD_COLOR_WHITE);                        
     lcd.DisplayStringAtLine(0,(uint8_t*) "   GSM TEST ");
    


    while (true)
        {
            led1=!led1;
             if(!GSM_Init())
             {
                ;
             }
             else
             {
                ;
             }
        }

}